diff --git a/ldap/servers/plugins/chainingdb/cb_search.c b/ldap/servers/plugins/chainingdb/cb_search.c
index dad2785..e2aa163 100644
--- a/ldap/servers/plugins/chainingdb/cb_search.c
+++ b/ldap/servers/plugins/chainingdb/cb_search.c
@@ -40,9 +40,8 @@ chainingdb_build_candidate_list ( Slapi_PBlock *pb )
 	const char          *target = NULL;
 	char                *filter;
 	char                **attrs = NULL;
-	struct timeval      timeout;
-	time_t              optime;
-	time_t              endbefore = 0;
+	struct timespec     expire_time;
+	struct timeval     timeout;
 	time_t              endtime = 0;
 	char                *matched_msg, *error_msg;
 	char                **referrals = NULL;
@@ -56,7 +55,6 @@ chainingdb_build_candidate_list ( Slapi_PBlock *pb )
 	slapi_pblock_get( pb, SLAPI_OPERATION, &op );
 	slapi_pblock_get( pb, SLAPI_SEARCH_STRFILTER, &filter );
 	slapi_pblock_get( pb, SLAPI_SEARCH_SCOPE, &scope );
-	slapi_pblock_get( pb, SLAPI_OPINITIATED_TIME, &optime );
 	slapi_pblock_get( pb, SLAPI_SEARCH_TARGET_SDN, &target_sdn );
 
 	target = slapi_sdn_get_dn(target_sdn);
@@ -94,8 +92,9 @@ chainingdb_build_candidate_list ( Slapi_PBlock *pb )
 	slapi_pblock_get( pb, SLAPI_SEARCH_ATTRS, &attrs );
 	slapi_pblock_get( pb, SLAPI_SEARCH_ATTRSONLY, &attrsonly );
 	slapi_pblock_get( pb, SLAPI_REQCONTROLS, &controls );
-	slapi_pblock_get( pb, SLAPI_SEARCH_TIMELIMIT, &timelimit );
 	slapi_pblock_get( pb, SLAPI_SEARCH_SIZELIMIT, &sizelimit );
+	slapi_pblock_get( pb, SLAPI_SEARCH_TIMELIMIT, &timelimit );
+	slapi_operation_time_expiry(op, (time_t)timelimit, &expire_time);
 	slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_SET,NULL);
 
 	if ((scope != LDAP_SCOPE_BASE) && (scope != LDAP_SCOPE_ONELEVEL) && (scope != LDAP_SCOPE_SUBTREE)) {
@@ -143,20 +142,25 @@ chainingdb_build_candidate_list ( Slapi_PBlock *pb )
 	** Time limit management.
 	** Make sure the operation has not expired
 	*/
-
-	if ( timelimit == -1 )  {
-		timeout.tv_sec = timeout.tv_usec = 0;
+	if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+		cb_send_ldap_result( pb, LDAP_TIMELIMIT_EXCEEDED, NULL,NULL, 0, NULL);
+		slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_ENTRY, NULL );
+		return 1;
+	}
+	/* Set the timeout for ldap_search_ext */
+	/* for some reasons, it is an error to pass in a zero'd timeval */
+	/* to ldap_search_ext()							*/
+	if ( timelimit == -1 || timelimit == 0)  {
+		timeout.tv_sec = -1;
+		timeout.tv_usec = -1;
 	} else {
-		time_t now=current_time();
-		endbefore=optime + timelimit;
-		if (now >= endbefore) {
-			cb_send_ldap_result( pb, LDAP_TIMELIMIT_EXCEEDED, NULL,NULL, 0, NULL);
-			slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_ENTRY, NULL );
-			return 1;
-		}
-		timeout.tv_sec=(time_t)timelimit-(now-optime);
+		/* Get the elapsed op time to fix our time limit */
+		struct timespec elapsed;
+		slapi_operation_time_elapsed(op, &elapsed);
+		timeout.tv_sec = ((time_t)timelimit) - elapsed.tv_sec;
 		timeout.tv_usec=0;
 	}
+	
 
 	/* Operational attribute support for internal searches:         */
 	/* The front-end relies on the fact that operational attributes */
@@ -179,7 +183,7 @@ chainingdb_build_candidate_list ( Slapi_PBlock *pb )
 	}
 
 	/* Grab a connection handle */
-	rc = cb_get_connection(cb->pool, &ld, &cnx, &timeout, &cnxerrbuf);
+	rc = cb_get_connection(cb->pool, &ld, &cnx, &expire_time, &cnxerrbuf);
 	if (LDAP_SUCCESS != rc) {
 		static int warned_get_conn = 0;
 		if (!warned_get_conn) {
@@ -230,14 +234,10 @@ chainingdb_build_candidate_list ( Slapi_PBlock *pb )
 	ctx->ld=ld;
 	ctx->cnx=cnx;
 
-	/* for some reasons, it is an error to pass in a zero'd timeval */
-	/* to ldap_search_ext()					        */
-	if ((timeout.tv_sec==0) && (timeout.tv_usec==0))
-		timeout.tv_sec=timeout.tv_usec=-1;
-
  	/* heart-beat management */
-	if (cb->max_idle_time>0)
-		endtime=current_time() + cb->max_idle_time;
+	if (cb->max_idle_time>0) {
+		endtime=slapi_current_utc_time() + cb->max_idle_time;
+	}
 
 	rc = ldap_search_ext(ld ,target,scope,filter,attrs,attrsonly,
 	                     ctrls, NULL, &timeout,sizelimit, &(ctx->msgid) );
@@ -282,18 +282,16 @@ chainingdb_build_candidate_list ( Slapi_PBlock *pb )
 
 		case 0:
 			/* Local timeout management */
-			if (timelimit != -1) {
-				if (current_time() > endbefore) {
-					slapi_log_err(SLAPI_LOG_PLUGIN, CB_PLUGIN_SUBSYSTEM,
-						"chainingdb_build_candidate_list - Local timeout expiration\n");
-					cb_send_ldap_result(pb,LDAP_TIMELIMIT_EXCEEDED,
-						NULL,NULL, 0, NULL);
-					/* Force connection close */
-					cb_release_op_connection(cb->pool,ld,1);
-					ldap_msgfree(res);
-					slapi_ch_free((void **)&ctx);
-					return 1;
-				}
+			if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+				slapi_log_err(SLAPI_LOG_PLUGIN, CB_PLUGIN_SUBSYSTEM,
+					"chainingdb_build_candidate_list - Local timeout expiration\n");
+				cb_send_ldap_result(pb,LDAP_TIMELIMIT_EXCEEDED,
+					NULL,NULL, 0, NULL);
+				/* Force connection close */
+				cb_release_op_connection(cb->pool,ld,1);
+				ldap_msgfree(res);
+				slapi_ch_free((void **)&ctx);
+				return 1;
 			}
 			/* heart-beat management */
 			if ((rc=cb_ping_farm(cb,cnx,endtime)) != LDAP_SUCCESS) {
@@ -399,7 +397,7 @@ chainingdb_next_search_entry ( Slapi_PBlock *pb )
 	int			sizelimit, timelimit;
 	int			rc, parse_rc, retcode;
 	int			i, attrsonly;
-	time_t			optime;
+	struct timespec expire_time;
 	LDAPMessage 		*res=NULL;
 	char 			*matched_msg,*error_msg;
 	cb_searchContext 	*ctx=NULL;
@@ -409,6 +407,7 @@ chainingdb_next_search_entry ( Slapi_PBlock *pb )
 	cb_backend_instance 	* cb=NULL;
 	Slapi_Backend		* be;
 	time_t			endtime = 0;
+	Slapi_Operation *op;
 
 	matched_msg=error_msg=NULL;
 
@@ -417,7 +416,8 @@ chainingdb_next_search_entry ( Slapi_PBlock *pb )
 	slapi_pblock_get( pb, SLAPI_SEARCH_TIMELIMIT, &timelimit );
 	slapi_pblock_get( pb, SLAPI_SEARCH_SIZELIMIT, &sizelimit );
 	slapi_pblock_get( pb, SLAPI_SEARCH_TARGET_SDN, &target_sdn );
-	slapi_pblock_get( pb, SLAPI_OPINITIATED_TIME, &optime );
+	slapi_pblock_get( pb, SLAPI_OPERATION, &op);
+	slapi_operation_time_expiry(op, (time_t)timelimit, &expire_time);
 	slapi_pblock_get( pb, SLAPI_SEARCH_ATTRSONLY, &attrsonly );
 
 	cb = cb_get_instance(be);
@@ -452,23 +452,20 @@ chainingdb_next_search_entry ( Slapi_PBlock *pb )
 
 		int n;
 		Slapi_Entry ** ptr;
-		if ( (timelimit != -1) && (timelimit != 0)) {
- 			time_t now=current_time();
-
-                	if (now > (optime + timelimit)) {
-                        	cb_send_ldap_result( pb, LDAP_TIMELIMIT_EXCEEDED, NULL,NULL, 0, NULL);
-				slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_SET,NULL );
-        			slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_ENTRY,NULL);
+		if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+			cb_send_ldap_result( pb, LDAP_TIMELIMIT_EXCEEDED, NULL,NULL, 0, NULL);
+			slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_SET,NULL );
+			slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_ENTRY,NULL);
 
-                		for ( n = 0, ptr=(Slapi_Entry **)ctx->data; ptr != NULL && ptr[n] != NULL; n++ ) {
-					slapi_entry_free(ptr[n]);
-				}
-				if (ctx->data)
-					slapi_ch_free((void **)&ctx->data);
-				slapi_ch_free((void **)&ctx);
-                        	return -1;
+			for ( n = 0, ptr=(Slapi_Entry **)ctx->data; ptr != NULL && ptr[n] != NULL; n++ ) {
+				slapi_entry_free(ptr[n]);
 			}
-                }
+			if (ctx->data) {
+				slapi_ch_free((void **)&ctx->data);
+			}
+			slapi_ch_free((void **)&ctx);
+			return -1;
+		}
 
 		/*
 		** Return the Slapi_Entry of the result set one
@@ -497,15 +494,16 @@ chainingdb_next_search_entry ( Slapi_PBlock *pb )
 	 * the context.
 	 */
 
- 	/* Poll the server for the results of the search operation. 
-         * Passing LDAP_MSG_ONE indicates that you want to receive 
-         * the entries one at a time, as they come in.  If the next
-         * entry that you retrieve is NULL, there are no more entries. 
+	/* Poll the server for the results of the search operation. 
+	 * Passing LDAP_MSG_ONE indicates that you want to receive 
+	 * the entries one at a time, as they come in.  If the next
+	 * entry that you retrieve is NULL, there are no more entries. 
 	 */
 	
 	/* heart-beat management */
-       	if (cb->max_idle_time>0)
-	       	endtime=current_time() + cb->max_idle_time;
+		if (cb->max_idle_time>0) {
+			endtime=slapi_current_utc_time() + cb->max_idle_time;
+		}
 
 	while (1) {
 
@@ -579,8 +577,9 @@ chainingdb_next_search_entry ( Slapi_PBlock *pb )
 		case LDAP_RES_SEARCH_ENTRY:
 
 			/* heart-beat management */
-       			if (cb->max_idle_time>0)
-	       			endtime=current_time() + cb->max_idle_time;
+       			if (cb->max_idle_time>0) {
+	       			endtime=slapi_current_utc_time() + cb->max_idle_time;
+				}
 
          		/* The server sent one of the entries found by the search */
 			if ((entry = cb_LDAPMessage2Entry(ctx->ld,res,attrsonly)) == NULL) {
@@ -610,8 +609,9 @@ chainingdb_next_search_entry ( Slapi_PBlock *pb )
 			 */
 		
 			/* heart-beat management */
-			if (cb->max_idle_time>0)
-				endtime=current_time() + cb->max_idle_time;
+			if (cb->max_idle_time>0) {
+				endtime=slapi_current_utc_time() + cb->max_idle_time;
+			}
 
 			parse_rc = ldap_parse_reference( ctx->ld, res, &referrals, NULL, 1 );
 			if ( parse_rc != LDAP_SUCCESS ) {
diff --git a/ldap/servers/plugins/dna/dna.c b/ldap/servers/plugins/dna/dna.c
index 1ae29dd..50840ac 100644
--- a/ldap/servers/plugins/dna/dna.c
+++ b/ldap/servers/plugins/dna/dna.c
@@ -894,7 +894,7 @@ dna_load_plugin_config(Slapi_PBlock *pb, int use_eventq)
          * performing the operation at this point when
          * starting up  would cause the change to not
          * get changelogged. */
-        time(&now);
+        now = slapi_current_utc_time();
         eq_ctx = slapi_eq_once(dna_update_config_event, NULL, now + 30);
     } else {
         dna_update_config_event(0, NULL);
diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index f11e903..3c6870a 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -3388,15 +3388,15 @@ static void _cl5TrimCleanup(void)
 
 static int _cl5TrimMain (void *param __attribute__((unused)))
 {
-	time_t timePrev = current_time ();
-	time_t timeCompactPrev = current_time ();
+	time_t timePrev = slapi_current_utc_time();
+	time_t timeCompactPrev = slapi_current_utc_time();
 	time_t timeNow;
 
 	PR_AtomicIncrement (&s_cl5Desc.threadCount);
 
 	while (s_cl5Desc.dbState != CL5_STATE_CLOSING)
 	{
-		timeNow = current_time ();
+		timeNow = slapi_current_utc_time();
 		if (timeNow - timePrev >= s_cl5Desc.dbTrim.trimInterval)
 		{
 			/* time to trim */
@@ -4094,7 +4094,7 @@ static PRBool _cl5CanTrim (time_t time, long *numToTrim)
 	}
 
 	if (time) {
-		return (current_time () - time > s_cl5Desc.dbTrim.maxAge);
+		return (slapi_current_utc_time() - time > s_cl5Desc.dbTrim.maxAge);
 	} else {
 		return PR_TRUE;
 	}
@@ -4972,7 +4972,7 @@ static int _cl5WriteOperationTxn(const char *replName, const char *replGen,
 	}
 
 	/* assign entry time - used for trimming */
-	entry.time = current_time (); 
+	entry.time = slapi_current_utc_time();
 	entry.op = (slapi_operation_parameters *)op;
 
 	/* construct the key */
diff --git a/ldap/servers/plugins/replication/repl5_backoff.c b/ldap/servers/plugins/replication/repl5_backoff.c
index 0fded96..8e349be 100644
--- a/ldap/servers/plugins/replication/repl5_backoff.c
+++ b/ldap/servers/plugins/replication/repl5_backoff.c
@@ -114,7 +114,7 @@ backoff_reset(Backoff_Timer *bt, slapi_eq_fn_t callback, void *callback_data)
 		bt->next_interval = bt->initial_interval;
 	}
 	/* Schedule the callback */
-	time(&bt->last_fire_time);
+	bt->last_fire_time = slapi_current_utc_time();
 	return_value = bt->last_fire_time + bt->next_interval;
 	bt->pending_event = slapi_eq_once(bt->callback, bt->callback_arg,
 		return_value);
@@ -184,7 +184,7 @@ backoff_expired(Backoff_Timer *bt, int margin)
 
 	PR_ASSERT(NULL != bt);
 	PR_Lock(bt->lock);
-	return_value = (current_time() >= (bt->last_fire_time + bt->next_interval + margin));
+	return_value = (slapi_current_utc_time() >= (bt->last_fire_time + bt->next_interval + margin));
 	PR_Unlock(bt->lock);
 	return return_value;
 }
diff --git a/ldap/servers/plugins/replication/repl5_connection.c b/ldap/servers/plugins/replication/repl5_connection.c
index 55ebd54..dacef9f 100644
--- a/ldap/servers/plugins/replication/repl5_connection.c
+++ b/ldap/servers/plugins/replication/repl5_connection.c
@@ -389,7 +389,7 @@ conn_read_result_ex(Repl_Connection *conn, char **retoidp, struct berval **retda
 				if (block)
 				{
 					/* Did the connection's timeout expire ? */
-					time_now = time( NULL );
+					time_now = slapi_current_utc_time();
 					if (conn->timeout.tv_sec <= ( time_now - start_time ))
 					{
 						/* We timed out */
@@ -756,7 +756,7 @@ conn_is_available(Repl_Connection *conn)
 {
     time_t poll_timeout_sec = 1; /* Polling for 1sec */
     time_t yield_delay_msec = 100; /* Delay to wait */
-    time_t start_time = time( NULL );
+    time_t start_time = slapi_current_utc_time();
     time_t time_now;
     ConnResult return_value = CONN_OPERATION_SUCCESS;
     
@@ -766,7 +766,7 @@ conn_is_available(Repl_Connection *conn)
             /* in case of timeout we return CONN_TIMEOUT only
              * if the RA.timeout is exceeded
              */
-            time_now = time(NULL);
+            time_now = slapi_current_utc_time();
             if (conn->timeout.tv_sec <= (time_now - start_time)) {
                 break;
             } else {
@@ -1141,7 +1141,7 @@ conn_start_linger(Repl_Connection *conn)
 			agmt_get_long_name(conn->agmt));
 		return;
 	}
-	time(&now);
+	now = slapi_current_utc_time();
 	PR_Lock(conn->lock);
 	if (conn->linger_active)
 	{
@@ -2185,7 +2185,7 @@ repl5_start_debug_timeout(int *setlevel)
 {
 	Slapi_Eq_Context eqctx = 0;
 	if (s_debug_timeout && s_debug_level) {
-		time_t now = time(NULL);
+		time_t now = slapi_current_utc_time();
 		eqctx = slapi_eq_once(repl5_debug_timeout_callback, setlevel,
 							  s_debug_timeout + now);
 	}
diff --git a/ldap/servers/plugins/replication/repl5_inc_protocol.c b/ldap/servers/plugins/replication/repl5_inc_protocol.c
index 90491fd..68185bf 100644
--- a/ldap/servers/plugins/replication/repl5_inc_protocol.c
+++ b/ldap/servers/plugins/replication/repl5_inc_protocol.c
@@ -259,7 +259,7 @@ repl5_inc_result_threadmain(void *param)
 		char *uniqueid = NULL;
 		char *ldap_error_string = NULL;
 		time_t time_now = 0;
-		time_t start_time = time( NULL );
+		time_t start_time = slapi_current_utc_time();
 		int connection_error = 0;
 		int operation_code = 0;
 		int backoff_time = 1;
@@ -282,7 +282,7 @@ repl5_inc_result_threadmain(void *param)
 				/* We need to a) check that the 'real' timeout hasn't expired and
 				 * b) implement a backoff sleep to avoid spinning */
 				/* Did the connection's timeout expire ? */
-				time_now = time( NULL );
+				time_now = slapi_current_utc_time();
 				if (conn_get_timeout(conn) <= ( time_now - start_time ))
 				{
 					/* We timed out */
@@ -373,7 +373,7 @@ repl5_inc_result_threadmain(void *param)
 		/* Should we stop ? */
 		PR_Lock(rd->lock);
 		if (!finished && yield_session && rd->abort != SESSION_ABORTED && rd->abort_time == 0) {
-			rd->abort_time = time( NULL );
+			rd->abort_time = slapi_current_utc_time();
 			rd->abort = SESSION_ABORTED;  /* only set the abort time once */
 			slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name, "repl5_inc_result_threadmain - "
 			                "Abort control detected, setting abort time...(%s)\n",
@@ -932,7 +932,7 @@ repl5_inc_run(Private_Repl_Protocol *prp)
                */
               if (STATE_BACKOFF == next_state){
                   /* Step the backoff timer */
-                  time(&now);
+                  now = slapi_current_utc_time();
                   next_fire_time = backoff_step(prp_priv->backoff);
                   /* And go back to sleep */
                   slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
@@ -978,7 +978,7 @@ repl5_inc_run(Private_Repl_Protocol *prp)
               release_replica (prp);
               done = 1;
               agmt_set_update_in_progress(prp->agmt, PR_FALSE);
-              agmt_set_last_update_end(prp->agmt, current_time());
+              agmt_set_last_update_end(prp->agmt, slapi_current_utc_time());
               /* MAB: I don't find the following status correct. How do we know it has
                * been stopped by an admin and not by a total update request, for instance?
                * In any case, how is this protocol shutdown situation different from all the
@@ -1074,7 +1074,7 @@ repl5_inc_run(Private_Repl_Protocol *prp)
                       /*
                        *  Reset our update times and status
                        */
-                      agmt_set_last_update_start(prp->agmt, current_time());
+                      agmt_set_last_update_start(prp->agmt, slapi_current_utc_time());
                       agmt_set_last_update_end(prp->agmt, 0);
                       agmt_set_update_in_progress(prp->agmt, PR_TRUE);
                       /*
@@ -1122,7 +1122,7 @@ repl5_inc_run(Private_Repl_Protocol *prp)
                       /* Set the updates times based off the result of send_updates() */
                       if(rc == UPDATE_NO_MORE_UPDATES){
                           /* update successful, set the end time */
-                    	  agmt_set_last_update_end(prp->agmt, current_time());
+                    	  agmt_set_last_update_end(prp->agmt, slapi_current_utc_time());
                       } else {
                           /* Failed to send updates, reset the start time to zero */
                           agmt_set_last_update_start(prp->agmt, 0);
@@ -1973,7 +1973,7 @@ send_updates(Private_Repl_Protocol *prp, RUV *remote_update_vector, PRUint32 *nu
 			/* See if the result thread has hit a problem */
 
 			if(!finished && rd->abort_time){
-				time_t current_time = time ( NULL );
+				time_t current_time = slapi_current_utc_time ();
 				if ((current_time - rd->abort_time) >= release_timeout){
 					rd->result = UPDATE_YIELD;
 					return_value = UPDATE_YIELD;
diff --git a/ldap/servers/plugins/replication/repl5_replica.c b/ldap/servers/plugins/replication/repl5_replica.c
index 55c270f..cf44bfd 100644
--- a/ldap/servers/plugins/replication/repl5_replica.c
+++ b/ldap/servers/plugins/replication/repl5_replica.c
@@ -246,7 +246,7 @@ replica_new_from_entry (Slapi_Entry *e, char *errortext, PRBool is_add_operation
        In that case the updated would fail but nothing bad would happen. The next
        scheduled update would save the state */
 	r->repl_eqcxt_rs = slapi_eq_repeat(replica_update_state, r->repl_name,
-                                       current_time () + START_UPDATE_DELAY, RUV_SAVE_INTERVAL);
+                                       slapi_current_utc_time() + START_UPDATE_DELAY, RUV_SAVE_INTERVAL);
 
 	if (r->tombstone_reap_interval > 0)
 	{
@@ -255,7 +255,7 @@ replica_new_from_entry (Slapi_Entry *e, char *errortext, PRBool is_add_operation
 		 * This will allow the server to fully start before consuming resources.
 		 */
 		r->repl_eqcxt_tr = slapi_eq_repeat(eq_cb_reap_tombstones, r->repl_name,
-										   current_time() + r->tombstone_reap_interval,
+										   slapi_current_utc_time() + r->tombstone_reap_interval,
 										   1000 * r->tombstone_reap_interval);
 	}
 
@@ -516,17 +516,14 @@ replica_subentry_update(Slapi_DN *repl_root, ReplicaId rid)
     LDAPMod * mods[2];
     LDAPMod mod;
     struct berval * vals[2];
-    char buf[20];
-    time_t curtime;
-    struct tm ltm;
+    char buf[SLAPI_TIMESTAMP_BUFSIZE];
     struct berval val;
     Slapi_PBlock *modpb = NULL;
     char *dn;
 
     replica_subentry_check(repl_root, rid);
-    curtime = current_time();
-    gmtime_r(&curtime, &ltm);
-    strftime(buf, sizeof (buf), "%Y%m%d%H%M%SZ", &ltm);
+
+    slapi_timestamp_utc_hr(buf, SLAPI_TIMESTAMP_BUFSIZE);
 
     slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name, "subentry_update called at %s\n", buf);
 
@@ -1214,7 +1211,7 @@ replica_is_updatedn (Replica *r, const Slapi_DN *sdn)
     if (r->groupdn_list) {
         /* check and rebuild groupdns */
         if (r->updatedn_group_check_interval > -1) {
-            time_t now = time(NULL);
+            time_t now = slapi_current_utc_time();
             if (now - r->updatedn_group_last_check > r->updatedn_group_check_interval) {
                 Slapi_ValueSet *updatedn_groups_copy = NULL;
                 ReplicaUpdateDNList groupdn_list = replica_updatedn_list_new(NULL);
@@ -1652,7 +1649,7 @@ replica_set_enabled (Replica *r, PRBool enable)
         if (r->repl_eqcxt_rs == NULL)   /* event is not already registered */
         {
             r->repl_eqcxt_rs = slapi_eq_repeat(replica_update_state, r->repl_name,
-                                               current_time() + START_UPDATE_DELAY, RUV_SAVE_INTERVAL);  
+                                               slapi_current_utc_time() + START_UPDATE_DELAY, RUV_SAVE_INTERVAL);  
         }
     }
     else    /* disable */
@@ -3907,7 +3904,7 @@ replica_set_tombstone_reap_interval (Replica *r, long interval)
 	if ( interval > 0 && r->repl_eqcxt_tr == NULL )
 	{
 		r->repl_eqcxt_tr = slapi_eq_repeat (eq_cb_reap_tombstones, r->repl_name,
-											current_time() + r->tombstone_reap_interval,
+											slapi_current_utc_time() + r->tombstone_reap_interval,
 											1000 * r->tombstone_reap_interval);
 		slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
 			"replica_set_tombstone_reap_interval - tombstone_reap event (interval=%ld) was %s\n",
diff --git a/ldap/servers/plugins/replication/repl5_ruv.c b/ldap/servers/plugins/replication/repl5_ruv.c
index d59e6d2..25f61e2 100644
--- a/ldap/servers/plugins/replication/repl5_ruv.c
+++ b/ldap/servers/plugins/replication/repl5_ruv.c
@@ -666,7 +666,7 @@ set_max_csn_nolock_ext(RUV *ruv, const CSN *max_csn, const char *replica_purl, P
 		if (!must_be_greater || (csn_compare(replica->csn, max_csn) < 0)) {
 			csn_free(&replica->csn);
 			replica->csn = csn_dup(max_csn);
-			replica->last_modified = current_time();
+			replica->last_modified = slapi_current_utc_time();
 		} else {
 			char csn1[CSN_STRSIZE+1];
 			char csn2[CSN_STRSIZE+1];
@@ -748,7 +748,7 @@ ruv_set_csns(RUV *ruv, const CSN *csn, const char *replica_purl)
 				{
 					replica->csn = csn_dup(csn);
 				}
-				replica->last_modified = current_time();
+				replica->last_modified = slapi_current_utc_time();
 				if (replica_purl && (NULL == replica->replica_purl ||
 					strcmp(replica->replica_purl, replica_purl) != 0))
 				{
@@ -810,7 +810,7 @@ ruv_set_csns_keep_smallest(RUV *ruv, const CSN *csn)
 			{
 				csn_free(&replica->csn);
 				replica->csn = csn_dup(csn);
-				replica->last_modified = current_time();
+				replica->last_modified = slapi_current_utc_time();
 			}
 			
 			return_value = RUV_SUCCESS;
@@ -1891,7 +1891,7 @@ ruvAddReplica (RUV *ruv, const CSN *csn, const char *replica_purl)
 /* 	PR_ASSERT(replica->rid != READ_ONLY_REPLICA_ID); */
 	
 	replica->csn = csn_dup (csn);
-	replica->last_modified = current_time();
+	replica->last_modified = slapi_current_utc_time();
 	replica->min_csn = csn_dup (csn);
 
 	replica->replica_purl = slapi_ch_strdup(replica_purl);
diff --git a/ldap/servers/plugins/replication/repl5_tot_protocol.c b/ldap/servers/plugins/replication/repl5_tot_protocol.c
index cb10b16..ab113d3 100644
--- a/ldap/servers/plugins/replication/repl5_tot_protocol.c
+++ b/ldap/servers/plugins/replication/repl5_tot_protocol.c
@@ -114,7 +114,7 @@ static void repl5_tot_result_threadmain(void *param)
 	{
 		int message_id = 0;
 		time_t time_now = 0;
-		time_t start_time = time( NULL );
+		time_t start_time = slapi_current_utc_time();
 		int backoff_time = 1;
 
 		/* Read the next result */
@@ -133,7 +133,7 @@ static void repl5_tot_result_threadmain(void *param)
 				/* We need to a) check that the 'real' timeout hasn't expired and
 				 * b) implement a backoff sleep to avoid spinning */
 				/* Did the connection's timeout expire ? */
-				time_now = time( NULL );
+				time_now = slapi_current_utc_time();
 				if (conn_get_timeout(conn) <= ( time_now - start_time ))
 				{
 					/* We timed out */
@@ -347,7 +347,7 @@ repl5_tot_run(Private_Repl_Protocol *prp)
 	conn_set_timeout(prp->conn, agmt_get_timeout(prp->agmt));
 
     /* acquire remote replica */
-	agmt_set_last_init_start(prp->agmt, current_time());
+	agmt_set_last_init_start(prp->agmt, slapi_current_utc_time());
 retry:
     rc = acquire_replica (prp, REPL_NSDS50_TOTAL_PROTOCOL_OID, NULL /* ruv */);
     /* We never retry total protocol, even in case a transient error.
@@ -455,7 +455,7 @@ retry:
         cb_data.rc = 0;
         cb_data.num_entries = 1UL;
         cb_data.sleep_on_busy = 0UL;
-        cb_data.last_busy = current_time ();
+        cb_data.last_busy = slapi_current_utc_time ();
         cb_data.flowcontrol_detection = 0;
         cb_data.lock = PR_NewLock();
 
@@ -514,7 +514,7 @@ retry:
         cb_data.rc = 0;
         cb_data.num_entries = 0UL;
         cb_data.sleep_on_busy = 0UL;
-        cb_data.last_busy = current_time ();
+        cb_data.last_busy = slapi_current_utc_time ();
         cb_data.flowcontrol_detection = 0;
         cb_data.lock = PR_NewLock();
 
@@ -575,7 +575,7 @@ retry:
 	 * suitable messages will have been logged to the error log about the failure.
 	 */
 
-	agmt_set_last_init_end(prp->agmt, current_time());
+	agmt_set_last_init_end(prp->agmt, slapi_current_utc_time());
 	rc = cb_data.rc;
 	agmt_set_update_in_progress(prp->agmt, PR_FALSE);
 	agmt_update_done(prp->agmt, 1);
@@ -883,7 +883,7 @@ int send_entry (Slapi_Entry *e, void *cb_data)
 		}
 	
 		if (rc == CONN_BUSY) {
-			time_t now = current_time ();
+			time_t now = slapi_current_utc_time ();
 			if ((now - *last_busyp) < (*sleep_on_busyp + 10)) {
 				*sleep_on_busyp +=5;
 			}
diff --git a/ldap/servers/plugins/replication/repl_objset.c b/ldap/servers/plugins/replication/repl_objset.c
index 405914d..b81881c 100644
--- a/ldap/servers/plugins/replication/repl_objset.c
+++ b/ldap/servers/plugins/replication/repl_objset.c
@@ -97,7 +97,7 @@ repl_objset_destroy(Repl_Objset **o, time_t maxwait, FNFree panic_fn)
 	PR_ASSERT(NULL != o);
 	PR_ASSERT(NULL != *o);
 
-	time(&now);
+	now = slapi_current_utc_time();
 	stop_time = now + maxwait;
 
 	/*
@@ -133,7 +133,7 @@ repl_objset_destroy(Repl_Objset **o, time_t maxwait, FNFree panic_fn)
 				co = llistGetNext((*o)->objects, &cookie);
 		}
 		PR_Unlock((*o)->lock);
-		time(&now);
+		now = slapi_current_utc_time();
 		if (loopcount > 0)
 		{
 			DS_Sleep(PR_TicksPerSecond());
diff --git a/ldap/servers/plugins/replication/windows_connection.c b/ldap/servers/plugins/replication/windows_connection.c
index c5486e3..d819ba9 100644
--- a/ldap/servers/plugins/replication/windows_connection.c
+++ b/ldap/servers/plugins/replication/windows_connection.c
@@ -1223,7 +1223,7 @@ windows_conn_start_linger(Repl_Connection *conn)
 			agmt_get_long_name(conn->agmt));
 		return;
 	}
-	time(&now);
+	now = slapi_current_utc_time();
 	PR_Lock(conn->lock);
 	if (conn->linger_active)
 	{
diff --git a/ldap/servers/plugins/replication/windows_inc_protocol.c b/ldap/servers/plugins/replication/windows_inc_protocol.c
index b878f2b..94a2933 100644
--- a/ldap/servers/plugins/replication/windows_inc_protocol.c
+++ b/ldap/servers/plugins/replication/windows_inc_protocol.c
@@ -739,7 +739,7 @@ windows_inc_run(Private_Repl_Protocol *prp)
 					dev_debug("windows_inc_run(STATE_SENDING_UPDATES)");
 					agmt_set_update_in_progress(prp->agmt, PR_TRUE);
 					num_changes_sent = 0;
-					last_start_time = current_time();
+					last_start_time = slapi_current_utc_time();
 					agmt_set_last_update_start(prp->agmt, last_start_time);
 					/*
 					 * We've acquired the replica, and are ready to send any
@@ -750,7 +750,7 @@ windows_inc_run(Private_Repl_Protocol *prp)
 						windows_release_replica (prp);
 						done = 1;
 						agmt_set_update_in_progress(prp->agmt, PR_FALSE);
-						agmt_set_last_update_end(prp->agmt, current_time());
+						agmt_set_last_update_end(prp->agmt, slapi_current_utc_time());
 						/* MAB: I don't find the following status correct. How do we know it has
 						   been stopped by an admin and not by a total update request, for instance?
 						   In any case, how is this protocol shutdown situation different from all the 
@@ -892,7 +892,7 @@ windows_inc_run(Private_Repl_Protocol *prp)
 		run_dirsync = PR_FALSE;
 	}
 
-	agmt_set_last_update_end(prp->agmt, current_time());
+	agmt_set_last_update_end(prp->agmt, slapi_current_utc_time());
 	agmt_set_update_in_progress(prp->agmt, PR_FALSE);
 	agmt_update_done(prp->agmt, 0);
 	/* If timed out, close the connection after released the replica */
diff --git a/ldap/servers/plugins/replication/windows_tot_protocol.c b/ldap/servers/plugins/replication/windows_tot_protocol.c
index ad6c4f8..6de0e93 100644
--- a/ldap/servers/plugins/replication/windows_tot_protocol.c
+++ b/ldap/servers/plugins/replication/windows_tot_protocol.c
@@ -142,7 +142,7 @@ windows_tot_run(Private_Repl_Protocol *prp)
 	windows_conn_set_timeout(prp->conn, agmt_get_timeout(prp->agmt));
 
 	/* acquire remote replica */
-	agmt_set_last_init_start(prp->agmt, current_time());
+	agmt_set_last_init_start(prp->agmt, slapi_current_utc_time());
 	
 	rc = windows_acquire_replica (prp, &ruv, 0 /* don't check RUV for total protocol */);
 	/* We never retry total protocol, even in case a transient error.
@@ -204,7 +204,7 @@ windows_tot_run(Private_Repl_Protocol *prp)
 	cb_data.rc = 0;
 	cb_data.num_entries = 0UL;
 	cb_data.sleep_on_busy = 0UL;
-	cb_data.last_busy = current_time ();
+	cb_data.last_busy = slapi_current_utc_time ();
 
 	/* Don't send anything if one-way (ONE_WAY_SYNC_FROM_AD) is set. */
 	if ((one_way == ONE_WAY_SYNC_DISABLED) || (one_way == ONE_WAY_SYNC_TO_AD)) {
@@ -253,7 +253,7 @@ windows_tot_run(Private_Repl_Protocol *prp)
 	/* Save the dirsync cookie. */
 	windows_private_save_dirsync_cookie(prp->agmt);
 
-	agmt_set_last_init_end(prp->agmt, current_time());
+	agmt_set_last_init_end(prp->agmt, slapi_current_utc_time());
 	agmt_set_update_in_progress(prp->agmt, PR_FALSE);
 	agmt_update_done(prp->agmt, 1);
 
diff --git a/ldap/servers/plugins/retrocl/retrocl_po.c b/ldap/servers/plugins/retrocl/retrocl_po.c
index 1d85ea4..4631c76 100644
--- a/ldap/servers/plugins/retrocl/retrocl_po.c
+++ b/ldap/servers/plugins/retrocl/retrocl_po.c
@@ -619,7 +619,7 @@ int retrocl_postob (Slapi_PBlock *pb, int optype)
         return SLAPI_PLUGIN_SUCCESS;
     }
 
-    curtime = current_time();
+    curtime = slapi_current_utc_time();
     
     (void)slapi_pblock_get( pb, SLAPI_ORIGINAL_TARGET_DN, &dn );
 
diff --git a/ldap/servers/plugins/retrocl/retrocl_trim.c b/ldap/servers/plugins/retrocl/retrocl_trim.c
index 5f30217..4f1b57a 100644
--- a/ldap/servers/plugins/retrocl/retrocl_trim.c
+++ b/ldap/servers/plugins/retrocl/retrocl_trim.c
@@ -238,7 +238,7 @@ static int trim_changelog(void)
     int me,lt;
     
 
-    now = current_time();
+    now = slapi_current_utc_time();
 
     PR_Lock( ts.ts_s_trim_mutex );
     me = ts.ts_c_max_age;
